#include <DirectGLWindow.h>
#include <support/Locker.h>
#include <kernel/OS.h>

#define MAX_DEVICES 16

typedef struct ModeInfoRec ModeInfo;

typedef struct tagVertex
{
	GLfloat x,y,z;
}VERTEX;

typedef struct tagFace
{
	VERTEX v1,v2,v3;
}FACE;

typedef struct tagObject
{
	int num_faces;
	FACE* face;
}OBJECT;

struct ModeInfoRec
{
	ModeInfo *next;
	uint32 xres;
	uint32 yres;
};

typedef struct GfxDeviceRec
{
	uint32 deviceID;
	ModeInfo *first;
} GfxDevice;


int32 render_thread( void *data );

class Wind : public BDirectGLWindow
{
public:
	Wind( const char *title );
	virtual ~Wind( void );

	virtual bool QuitRequested( void );
	virtual void MessageReceived( BMessage *msg );
	virtual void FrameResized( float width, float height );
	virtual BRect UpdateGLRect( BRect window_rect );
	
	virtual void DeviceInfo( uint32 device_id, uint32 monitor, const char *name, bool depth, bool stencil, bool accum );

	bool window_teardown;
	bool initialized;
			bool texture_enable;
	thread_id draw_thread;
	
private:
	status_t RestartGL( uint32 deviceID );
	static int32 render_thread( void *data );

	bool paused;
	bool vsync;
	
	BMenuItem *checkedDevice;
	BMenu *DeviceMenu;
	
	bool fullscreenEnabled;
	int32 fullscreenWidth;
	int32 fullscreenHeight;
	
	int32 currentDevice;
	GfxDevice devices[MAX_DEVICES];
	
	
//////////////////////// TEXTURE ADDITION /////////////////////
	
	/////// VARIABLES ///////////
GLuint texture[1];
BBitmap *texture_bits;
bool texture_loaded;
OBJECT object;

/////// FUNCTIONS ///////////
BBitmap *LoadTexture( const char *tex_file );
bool InitTexture();
bool LoadObject(const char * object_file, OBJECT* obj);
void DrawObject(OBJECT* obj, GLuint texture);
};